#ifndef LEVEL_H_
#define LEVEL_H_

typedef struct _VERTEX {
  float x, y;
} VERTEX;

typedef struct _ROOM {
  unsigned int nVertices;
  VERTEX *vertices;
} ROOM;

typedef struct _LEVEL {
  unsigned int nRooms;
  ROOM *rooms;
} LEVEL;

void addRoom(LEVEL *lvl, ROOM *room);
void deleteRoom(LEVEL *lvl, unsigned int n);

void addVertex(ROOM *room, VERTEX *v);
void insertVertex(ROOM *room, VERTEX *v, unsigned int n);
void deleteVertex(ROOM *room, unsigned int n);

void freeLevel(LEVEL *lvl);

#endif /*LEVEL_H_*/
